| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
uiMultiFlatViewControl Class Reference
uiFlatView

`#include <uimultiflatviewcontrol.h>`

Inheritance diagram for uiMultiFlatViewControl:
[legend]

## Public Member Functions
| uiMultiFlatViewControl (uiFlatViewer &, const Setup &)
| ~uiMultiFlatViewControl ()
uiFlatViewer * | activeVwr () const
uiToolBar * | getToolBar (int idx)
bool | setActiveVwr (int vwridx)
void | setD2TModels (const ObjectSet< const TimeDepthModel > &d2t)
void | setDrawZoomBoxes (bool yn)
void | setFlattened (bool flattened, const TypeSet< float > *depths)
void | setNewView (Geom::Point2D< double > mousepos, Geom::Size2D< double > size, uiFlatViewer *=nullptr) override
void | setParsButToolTip (const uiFlatViewer &, const uiString &)
void | setViewerType (const uiFlatViewer *vwr, bool isintime)
void | setZoomCoupled (bool yn)
Public Member Functions inherited from uiFlatViewStdControl
| uiFlatViewStdControl (uiFlatViewer &, const Setup &)
virtual | ~uiFlatViewStdControl ()
virtual uiFlatViewColTabEd * | colTabEd ()
NotifierAccess * | editPushed ()
virtual uiToolBar * | editToolBar ()
float | getCurrentPosPerCM (bool forx1) const
bool | isEditModeOn () const
bool | isRubberBandOn () const
void | setEditMode (bool yn)
virtual uiToolBar * | toolBar ()
Public Member Functions inherited from uiFlatViewControl
| ~uiFlatViewControl ()
void | addViewer (uiFlatViewer &)
| No attaching done. Viewer may be in other window.
virtual void | doPropertiesDialog (int vieweridx=0)
virtual void | flip (bool hor)
| reverses uiWorldRect's LR or TB swapping
TypeSet< uiWorldRect > | getBoundingBoxes () const
| Returns bounding boxes of all viewers.
int | getViewerIdx (const MouseEventHandler *, bool ofscene)
void | reInitZooms ()
void | removeViewer (uiFlatViewer &)
const FlatView::ZoomMgr & | zoomMgr () const
Public Member Functions inherited from uiGroup
| uiGroup (uiParent *, const char *nm="uiGroup", bool manage=true)
virtual | ~uiGroup ()
void | adjustSize ()
uiObject * | attachObj ()
const uiObject * | attachObj () const
uiObject * | hAlignObj ()
uiObject * | hCenterObj ()
uiMainWin * | mainwin () override
| mOD_DisableCopy (uiGroup) inline operator const uiGroupObj *() const
| operator const uiObject & () const
| operator uiGroupObj * ()
| operator uiObject & ()
uiParent * | parent ()
const uiParent * | parent () const
Notifier< uiBaseObject > & | postFinalise () override
Notifier< uiBaseObject > & | postFinalize () override
Notifier< uiBaseObject > & | preFinalise () override
Notifier< uiBaseObject > & | preFinalize () override
void | setBorder (int l, int t, int r, int b)
void | setBorder (int)
void | setChildrenSensitive (bool)
void | setFrame (bool yn=true)
void | setHAlignObj (uiGroup *o)
void | setHAlignObj (uiObject *)
void | setHCenterObj (uiGroup *o)
void | setHCenterObj (uiObject *)
void | setHSpacing (int)
void | setIsMain (bool)
| internal use only. Tells the layout manager it's a toplevel mngr.
void | setNoBackGround ()
virtual void | setSize (const uiSize &)
void | setSpacing (int s=0)
void | setVSpacing (int)
Public Member Functions inherited from uiParent
uiSize | actualsize (bool inclborder=true) const
uiSize | actualSize (bool include_border) const
void | addChild (uiBaseObject &)
void | attach (ConstraintType, int margin=-1)
void | attach (ConstraintType, uiObject *oth, int margin=-1, bool reciprocal=true)
void | attach (ConstraintType, uiParent *oth, int margin=-1, bool reciprocal=true)
void | attachChild (ConstraintType tp, uiObject *child, uiObject *other, int margin, bool reciprocal)
OD::Color | backgroundColor () const
const ObjectSet< uiBaseObject > * | childList () const
void | deepRedraw (CallBacker *)
virtual void | display (bool yn, bool shrk=false, bool maximize=false)
const uiFont * | font () const
bool | hasFocus () const
bool | isDisplayed () const
uiObject * | mainObject ()
const uiObject * | mainObject () const
void | manageChild (uiBaseObject &, uiObjectBody &)
uiParentBody * | pbody ()
const uiParentBody * | pbody () const
int | prefHNrPics () const
int | prefVNrPics () const
virtual void | reDraw (bool deep)
OD::Color | roBackgroundColor () const
bool | sensitive () const
void | setBackgroundColor (const OD::Color &)
void | setCaption (const uiString &)
void | setCursor (const MouseCursor &)
void | setFocus ()
void | setFont (const uiFont &)
void | setPrefHeight (int h)
void | setPrefHeightInChar (float h)
void | setPrefHeightInChar (int h)
void | setPrefWidth (int w)
void | setPrefWidthInChar (float w)
void | setPrefWidthInChar (int w)
void | setSensitive (bool yn=true)
void | setStretch (int h, int v)
void | shallowRedraw (CallBacker *)
int | stretch (bool h) const
void | translateText () override
Public Member Functions inherited from uiBaseObject
virtual | ~uiBaseObject ()
int | beginCmdRecEvent (const BufferString &msg)
int | beginCmdRecEvent (const char *msg=0)
int | beginCmdRecEvent (od_uint64 id, const char *msg=0)
uiBody * | body ()
const uiBody * | body () const
void | clear ()
void | endCmdRecEvent (int refnr, const char *msg=0)
void | endCmdRecEvent (od_uint64 id, int refnr, const char *msg=0)
void | finalise ()
bool | finalised () const
bool | finalized () const
virtual QWidget * | getWidget ()
const QWidget * | getWidget () const
| mOD_DisableCopy (uiBaseObject) void final ize()
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Protected Member Functions
bool | handleUserClick (int vwridx) override
void | parsCB (CallBacker *) override
void | pinchZoomCB (CallBacker *) override
void | removeAnnotationsCB (CallBacker *)
void | rubBandCB (CallBacker *) override
void | setVwrsToBoundingBox () override
void | setZoomAreasCB (CallBacker *)
void | setZoomBoxesCB (CallBacker *)
void | updateZoomManager () override
| Should be called after the viewer is zoomed in/out.
void | vwrAdded (CallBacker *) override
void | wheelMoveCB (CallBacker *) override
void | zoomCB (CallBacker *) override
Protected Member Functions inherited from uiFlatViewStdControl
void | aspectRatioCB (CallBacker *)
virtual void | cancelZoomCB (CallBacker *)
void | clearToolBar ()
virtual void | coltabChg (CallBacker *)
void | createMenuCB (CallBacker *)
virtual void | dispChgCB (CallBacker *)
void | displayColTabCB (CallBacker *)
void | displayScaleBarCB (CallBacker *)
void | doZoom (bool zoomin, bool onlyvertzoom, uiFlatViewer &)
virtual void | dragModeCB (CallBacker *)
void | editModeCB (CallBacker *)
void | finalPrepare () override
void | fitToScreenCB (CallBacker *)
void | flipCB (CallBacker *)
virtual void | gotoHomeZoomCB (CallBacker *)
void | handDragged (CallBacker *) override
void | handDragging (CallBacker *) override
void | handDragStarted (CallBacker *) override
void | handleMenuCB (CallBacker *)
void | helpCB (CallBacker *)
void | homeZoomOptSelCB (CallBacker *)
void | keyPressCB (CallBacker *) override
virtual void | rubBandUsedCB (CallBacker *)
void | setViewToCustomZoomLevel (uiFlatViewer &) override
void | setVwrCursor (uiFlatViewer &, const MouseCursor &)
void | updatePosButtonStates ()
void | updateZoomLevel (float x1pospercm, float x2pospercm)
void | updateZoomLevel (float x1start, float x2start, float x1pospercm, float x2pospercm)
void | zoomApplyCB (CallBacker *)
virtual void | zoomChgCB (CallBacker *)
Protected Member Functions inherited from uiFlatViewControl
| uiFlatViewControl (uiFlatViewer &, uiParent *, bool)
virtual void | applyProperties (CallBacker *cb)
virtual bool | canReUseZoomSettings (Geom::Point2D< double >, Geom::Size2D< double >) const
virtual void | dataChangeCB (CallBacker *)
void | initZoom (CallBacker *)
MouseEventHandler & | mouseEventHandler (int vwridx, bool ofscene)
virtual void | mouseMoveCB (CallBacker *)
virtual void | onFinalize (CallBacker *)
virtual void | propDlgClosed (CallBacker *)
virtual void | saveProperties (FlatView::Viewer &)
virtual void | setNewWorldRect (uiFlatViewer &, uiWorldRect &)
virtual void | usrClickCB (CallBacker *)
Protected Member Functions inherited from uiGroup
void | attach_ (ConstraintType, uiObject *oth, int margin=-1, bool reciprocal=true) override
void | bodyDel (CallBacker *)
uiObject * | mainobject () override
virtual void | reDraw_ (bool deep)
void | reSizeChildren (const uiObject *, float, float)
void | setFrameStyle (int)
void | setShrinkAllowed (bool)
bool | shrinkAllowed ()
void | uiobjDel (CallBacker *)
Protected Member Functions inherited from uiParent
| uiParent (const char *nm, uiParentBody *)
| ~uiParent ()
| mOD_DisableCopy (uiParent) virtual void attach_(ConstraintType
Protected Member Functions inherited from uiBaseObject
| uiBaseObject (const char *nm, uiBody *=nullptr)
void | setBody (uiBody *b)
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Protected Attributes
uiFlatViewer * | activevwr_
bool | drawzoomboxes_ = false
bool | iszoomcoupled_ = true
TypeSet< int > | parsbuts_
ObjectSet< uiToolBar > | toolbars_
MFVCViewManager | viewmgr_
ObjectSet< FlatView::AuxData > | zoomboxes_
Protected Attributes inherited from uiFlatViewStdControl
int | cancelzoombut_ = -1
int | coltabbut_ = -1
uiFlatViewColTabEd * | ctabed_ = nullptr
float | defx1pospercm_ = mUdf(float)
float | defx2pospercm_ = mUdf(float)
int | editbut_ = -1
uiToolBar * | edittb_ = nullptr
int | fittoscrnbut_ = -1
int | gotohomezoombut_ = -1
HelpKey | helpkey_
uiMenuHandler & | menu_
uiPoint | mousedownpt_
bool | mousepressed_ = false
int | parsbut_ = -1
MenuItem | propertiesmnuitem_
int | rubbandzoombut_ = -1
int | scalebarbut_ = -1
int | sethomezoombut_ = -1
const Setup | setup_
uiToolBar * | tb_
int | vertzoominbut_ = -1
int | vertzoomoutbut_ = -1
uiFlatViewer & | vwr_
float | x1start_ = mUdf(float)
float | x2start_ = mUdf(float)
int | zoominbut_ = -1
int | zoomoutbut_ = -1
Protected Attributes inherited from uiFlatViewControl
bool | haverubber_
IOPar | infopars_
bool | initdone_ = false
uiFlatViewPropDlg * | propdlg_ = nullptr
ObjectSet< uiFlatViewer > | vwrs_
FlatView::ZoomMgr | zoommgr_
Protected Attributes inherited from uiGroup
uiGroupParentBody * | body_
uiGroupObj * | grpobj_
Protected Attributes inherited from uiParent
uiObject int | margin =-1
uiObject * | oth
uiObject int bool | reciprocal =true)
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Static Public Member Functions inherited from uiFlatViewStdControl
static void | getGlobalZoomLevel (float &x1pospercm, float &x2pospercm, bool isvertical)
static void | setGlobalZoomLevel (float x1pospercm, float x2pospercm, bool isvertical)
Static Public Member Functions inherited from uiFlatViewControl
static uiWorldRect | getZoomOrPanRect (Geom::Point2D< double > mousepos, Geom::Size2D< double > newsz, const uiWorldRect &view, const uiWorldRect &bbox)
static const char * | sKeyViewerIdx ()
Static Public Member Functions inherited from uiGroup
static uiGroup * | gtDynamicCastToGrp (QWidget *)
Static Public Member Functions inherited from uiBaseObject
static void | addCmdRecorder (const CallBack &)
static void | removeCmdRecorder (const CallBack &)
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Public Attributes inherited from uiFlatViewControl
CNotifier< uiFlatViewControl, const IOPar & > | infoChanged
Notifier< uiFlatViewControl > | rubberBandUsed
Notifier< uiFlatViewControl > | viewerAdded
Notifier< uiFlatViewControl > | zoomChanged

## Detailed Description

<>

## Constructor & Destructor Documentation

## ◆ uiMultiFlatViewControl()

uiMultiFlatViewControl::uiMultiFlatViewControl | ( | uiFlatViewer & | ,
|  | const Setup & | )

## ◆ ~uiMultiFlatViewControl()

uiMultiFlatViewControl::~uiMultiFlatViewControl | ( |  | ) |

## Member Function Documentation

## ◆ activeVwr()

uiFlatViewer * uiMultiFlatViewControl::activeVwr | ( |  | ) | const
| inline

## ◆ getToolBar()

uiToolBar * uiMultiFlatViewControl::getToolBar | ( | int | idx | ) |
| inline

## ◆ handleUserClick()

bool uiMultiFlatViewControl::handleUserClick | ( | int | vwridx | ) |
| override protected virtual

Reimplemented from uiFlatViewStdControl.

## ◆ parsCB()

void uiMultiFlatViewControl::parsCB | ( | CallBacker * |  | ) |
| override protected virtual

Reimplemented from uiFlatViewStdControl.

## ◆ pinchZoomCB()

void uiMultiFlatViewControl::pinchZoomCB | ( | CallBacker * |  | ) |
| override protected virtual

Reimplemented from uiFlatViewStdControl.

## ◆ removeAnnotationsCB()

void uiMultiFlatViewControl::removeAnnotationsCB | ( | CallBacker * |  | ) |
| protected

## ◆ rubBandCB()

void uiMultiFlatViewControl::rubBandCB | ( | CallBacker * |  | ) |
| override protected virtual

Reimplemented from uiFlatViewControl.

## ◆ setActiveVwr()

bool uiMultiFlatViewControl::setActiveVwr | ( | int | vwridx | ) |

## ◆ setD2TModels()

void uiMultiFlatViewControl::setD2TModels | ( | const ObjectSet< const TimeDepthModel > & | d2t | ) |
| inline

## ◆ setDrawZoomBoxes()

void uiMultiFlatViewControl::setDrawZoomBoxes | ( | bool | yn | ) |
| inline

## ◆ setFlattened()

void uiMultiFlatViewControl::setFlattened | ( | bool | flattened,
|  | const TypeSet< float > * | depths )
| inline

## ◆ setNewView()

void uiMultiFlatViewControl::setNewView | ( | Geom::Point2D< double > | mousepos,
|  | Geom::Size2D< double > | newsize,
|  | uiFlatViewer * | = nullptr )
| override virtual

Pass centre instead of mousepos if there is no MouseEvent. Retains uiWorldRect's LR/TB swapping while changing the input to the actual new values. Use for setting new view while zoomin/zoom out only. Makes sure

Parameters

  mousepos | (pointed by MouseCursor) does not change after changing view and bitmaps are filled in extra available space without changing aspect ratio (if has to be constant) along with needed uiFlatViewer::setBoundingRect(const uiRect&).
  newsize |
  vwr |

Reimplemented from uiFlatViewControl.

## ◆ setParsButToolTip()

void uiMultiFlatViewControl::setParsButToolTip | ( | const uiFlatViewer & | ,
|  | const uiString & | )

## ◆ setViewerType()

void uiMultiFlatViewControl::setViewerType | ( | const uiFlatViewer * | vwr,
|  | bool | isintime )
| inline

## ◆ setVwrsToBoundingBox()

void uiMultiFlatViewControl::setVwrsToBoundingBox | ( |  | ) |
| override protected virtual

Reimplemented from uiFlatViewControl.

## ◆ setZoomAreasCB()

void uiMultiFlatViewControl::setZoomAreasCB | ( | CallBacker * |  | ) |
| protected

## ◆ setZoomBoxesCB()

void uiMultiFlatViewControl::setZoomBoxesCB | ( | CallBacker * |  | ) |
| protected

## ◆ setZoomCoupled()

void uiMultiFlatViewControl::setZoomCoupled | ( | bool | yn | ) |
| inline

## ◆ updateZoomManager()

void uiMultiFlatViewControl::updateZoomManager | ( |  | ) |
| override protected virtual

Should be called after the viewer is zoomed in/out.

Reimplemented from uiFlatViewControl.

## ◆ vwrAdded()

void uiMultiFlatViewControl::vwrAdded | ( | CallBacker * |  | ) |
| override protected virtual

Reimplemented from uiFlatViewStdControl.

## ◆ wheelMoveCB()

void uiMultiFlatViewControl::wheelMoveCB | ( | CallBacker * |  | ) |
| override protected virtual

Reimplemented from uiFlatViewStdControl.

## ◆ zoomCB()

void uiMultiFlatViewControl::zoomCB | ( | CallBacker * |  | ) |
| override protected virtual

Reimplemented from uiFlatViewStdControl.

## Member Data Documentation

## ◆ activevwr_

uiFlatViewer* uiMultiFlatViewControl::activevwr_
| protected

## ◆ drawzoomboxes_

bool uiMultiFlatViewControl::drawzoomboxes_ = false
| protected

## ◆ iszoomcoupled_

bool uiMultiFlatViewControl::iszoomcoupled_ = true
| protected

## ◆ parsbuts_

TypeSet<int> uiMultiFlatViewControl::parsbuts_
| protected

## ◆ toolbars_

ObjectSet<uiToolBar> uiMultiFlatViewControl::toolbars_
| protected

## ◆ viewmgr_

MFVCViewManager uiMultiFlatViewControl::viewmgr_
| protected

## ◆ zoomboxes_

ObjectSet<FlatView::AuxData> uiMultiFlatViewControl::zoomboxes_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025